Index: examples/python_tests/acme_rockets_intersection_rt0/query.py
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_intersection_rt0/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,9 +2,8 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
 cmd2: env ABAC_CN=1 keystore=`pwd` ./query.py
-
 """
 
@@ -14,10 +13,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem");
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -37,4 +40,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# can coyote buy rockets from Acme ?
 # role = "[keyid:Acme].role:buy_rockets"
 # p = "[keyid:coyote]" 
@@ -50,4 +66,5 @@
 
 ##########################################################################
+# can batman buy rockets from Acme ?
 # role = "[keyid:Acme].role:buy_rockets"
 # p = "[keyid:batman]" 
@@ -61,19 +78,2 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
-
-
Index: examples/python_tests/acme_rockets_intersection_rt0/run_test
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_intersection_rt0/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/acme_rockets_intersection_rt0/setup.py
===================================================================
--- examples/python_tests/acme_rockets_intersection_rt0/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_intersection_rt0/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,6 @@
 
 """
-  Setup 4 principal ID credentials
-
-  Acme, Coyote, WarnerBros and Batman
+See README for the semantics.  This creates four principals used
+by the example.
 
 """
Index: examples/python_tests/acme_rockets_rt0/README
===================================================================
--- examples/python_tests/acme_rockets_rt0/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_rt0/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,10 +1,10 @@
-#!/bin/sh
 #
 # The example makes use of 2 principals, Acme and Coyote.
 #
 # This example shows a very simple delegation of roles by Acme.  Acme's
-# buy_rockets role includes all of Acme's preferred customers.  The example
-# creates the principals and 2 credentials.  Credential 1 encodes the policy
-# that all of Acme's preferred customers can buy rockets from Acme and
+# buy_rockets role includes all of Acme's preferred customers.  The setup.py
+# creates the principals and the attr.py creates 2 policy credentials.  
+# Credential 1 encodes the policy that all of Acme's preferred customers 
+# can buy rockets from Acme and
 # Credential 2 defines the Coyote as an Acme preferred customer.
 
@@ -14,21 +14,10 @@
 # something other than a principal works (it doesn't).
 
-# acme_rockets_rt0_typed
+# acme_rockets_rt0
 
-creddy --generate --cn Acme
-creddy --generate --cn Coyote
+# Credential 1
+#[keyid:Acme].role:buy_rockets <- [keyid:Acme].role:preferred_customer 
 
-#[keyid:Acme].role:buy_rockets <- [keyid:Acme].role:preferred_customer 
-# Credential 1
-creddy --attribute \
-       --issuer Acme_ID.pem --key Acme_private.pem --role buy_rockets \
-       --subject-cert Acme_ID.pem --subject-role preferred_customer \
-       --out Acme_buy_rockets__Acme_preferred_customer_attr.der
+# Credential 2
+#[keyid:Acme].role:preferred_customer <- [keyid:Coyote]
 
-#[keyid:Acme].role:preferred_customer <- [keyid:Coyote]
-# Credential 2
-creddy --attribute \
-       --issuer Acme_ID.pem --key Acme_private.pem --role preferred_customer \
-       --subject-cert Coyote_ID.pem \
-       --out Acme_preferred_customer__Coyote_attr.der
-
Index: examples/python_tests/acme_rockets_rt0/attr.py
===================================================================
--- examples/python_tests/acme_rockets_rt0/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_rt0/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,17 +2,16 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 import os
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem");
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -26,11 +25,20 @@
 
 ################################################
+# Credential 1, only preferred_customer of Acme can buy_rockets
 #[keyid:Acme].role:buy_rockets <- [keyid:Acme].role:preferred_customer
 head = ABAC.Role(acme,"buy_rockets")
 tail = ABAC.Role(acme,"preferred_customer")
+
+# compose the attribute of a basic rt0 role rule
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# finalize the policy
 attr.attribute_bake()
+
+# create a policy file at the file system
 attr.attribute_write_cert("Acme_buy_rockets__Acme_preferred_customer_attr.der")
+
+# load the policy into current context by with the newly created policy file
 ctxt.load_attribute_file("Acme_buy_rockets__Acme_preferred_customer_attr.der")
 print attr.string() 
@@ -39,4 +47,5 @@
 
 #################################################
+# Credential 2
 #[keyid:Acme].role:preferred_customer <- [keyid:Coyote]
 head = ABAC.Role(acme,"preferred_customer")
@@ -51,4 +60,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/acme_rockets_rt0/query.py
===================================================================
--- examples/python_tests/acme_rockets_rt0/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_rt0/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 acmeID=ABAC.ID("Acme_ID.pem");
 acmeID.id_load_privkey_file("Acme_private.pem");
@@ -29,4 +33,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# is coyote a preferred_customer of Acme ?
 # role=[keyid:Acme].role:preferred_customer
 # p =[keyid:coyote]
@@ -39,4 +56,5 @@
 
 ##########################################################################
+# can coyote buy rockets from Acme ?
 # role=[keyid:Acme].role:buy_rockets
 # p =[keyid:coyote]
@@ -50,4 +68,5 @@
 
 ##########################################################################
+# is Acme a friend of coyote ?
 # role=[keyid:Coyote].role:friend
 # p=[keyid:Acme] 
@@ -59,18 +78,14 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-
 ##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
+# using complex role to ask a question.. expecting to fail 
+# role=[keyid:Acme].role:buy_rockets 
+# p=[keyid:Acme].role:preferred_customer
+role = ABAC.Role(acme,"buy_rockets")
+p = ABAC.Role(acme,"preferred_customer")
+print "\n===bad=============== Acme.buy_rockets <- Acme.preferred_customer"
+out = ctxt.query(role, p)
 for c in out[1]:
     print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
 
 
Index: examples/python_tests/acme_rockets_rt0/rocket.save
===================================================================
--- examples/python_tests/acme_rockets_rt0/rocket.save	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_rt0/rocket.save	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,3 +1,11 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
+
+...final principal set...
+(pAcme,keyid,y) 
+(pCoyote,keyid,y) 
+
+...final policy attribute set...
+pAcme.buy_rockets <- pAcme.preferred_customer
+pAcme.preferred_customer <- pCoyote
 
 ===good============ Acme.preferred_customer <- Coyote
@@ -13,13 +21,4 @@
 YAP query failed
 
-...final principal set...
-(pAcme,keyid,y) 
-(pCoyote,keyid,y) 
-
-
-
-...final policy attribute set...
-pAcme.buy_rockets <- pAcme.preferred_customer
-pAcme.preferred_customer <- pCoyote
-
-
+===bad=============== Acme.buy_rockets <- Acme.preferred_customer
+fail, a.o <- b.o and a.r <- a.r query is not implemented yet !!!
Index: examples/python_tests/acme_rockets_rt0/run_test
===================================================================
--- examples/python_tests/acme_rockets_rt0/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_rt0/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/acme_rockets_rt0/setup.py
===================================================================
--- examples/python_tests/acme_rockets_rt0/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/acme_rockets_rt0/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,8 +2,6 @@
 
 """
-  Setup 4 principal ID credentials
-
-  Acme, Coyote, WarnerBros and Batman
-
+See README for the semantics. 
+sets up 2 (Acme, Coyote) principal ID credentials
 """
 import os
@@ -12,7 +10,7 @@
 ctxt = ABAC.Context()
 
-alpha=ABAC.ID("Acme", 0)
-alpha.id_write_cert("Acme_ID.pem")
-alpha.id_write_privkey("Acme_private.pem")
+acme=ABAC.ID("Acme", 0)
+acme.id_write_cert("Acme_ID.pem")
+acme.id_write_privkey("Acme_private.pem")
 
 coyote=ABAC.ID("Coyote", 0)
Index: examples/python_tests/alice_rt1/README
===================================================================
--- examples/python_tests/alice_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alice_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,53 +1,61 @@
-#!/bin/sh
-
-## trying out different data param types
-
-# alice_rt1_typed
-
-creddy --generate --cn Alice
-creddy --generate --cn Hatter
-creddy --generate --cn MarchHare
-creddy --generate --cn Dormouse
-creddy --generate --cn Tea
-creddy --generate --cn Party 
-
-alice_keyid=`creddy --keyid --cert Alice_ID.pem`
-party_keyid=`creddy --keyid --cert Party_ID.pem`
-tea_keyid=`creddy --keyid --cert Tea_ID.pem`
-hatter_keyid=`creddy --keyid --cert Hatter_ID.pem`
-marchhare_keyid=`creddy --keyid --cert MarchHare_ID.pem`
-dormouse_keyid=`creddy --keyid --cert Dormouse_ID.pem`
-
-friendof_alice="friendOf-alice([keyid:$alice_keyid])"
-friendof_marchhare="friendOf([keyid:$marchhare_keyid])"
-guestof_marchhare="guestOf([keyid:$marchhare_keyid])"
-
-about_party="about([keyid:$tea_keyid],[time:20101010T],[boolean:true],[integer:4],[float:-200.0],[float:8],[time:20120205T182930],[string:'guest list'],[urn:'file://usr/local/party/~teaparty'])"
-
-about_other_party="about_other_party([keyid:$tea_keyid],[?],[integer:99],[time:?AAA],[integer:?BBB],[boolean:true],[integer:?])"
-
-about_time="about_time([time:20201101T])"
-about_another_time="about_another_time([time:20201101T182930])"
-about_key="about_key([keyid:$tea_keyid])"
-about_boolean="about_boolean([boolean:true])"
-about_integer="about_integer([integer:4])"
-about_another_integer="about_another_integer([integer:-7])"
-about_float="about_float([float:-200.0])"
-about_another_float="about_another_float([float:8])"
-about_third_float="about_another_float([float:0.22])"
-about_urn="about_urn([urn:'file://user/local/party/~sillyparty'])"
-about_string="about_string([string:'a confused party'])"
-about_string2="about_string([string:'a mangled \'string\''])"
+#
+# trying out different data param types
+#
+# alice_rt1
+#
+# 
+# [keyid:Party].role: about([keyid:tea],[time:20101010T],[boolean:true],[integer:4],
+#                  [float:-200.0],[float:8],[time:20120205T182930],[string:'a list'],
+#                  [urn:'file://usr/party/~teaparty'])
+#                  <- [keyid:Party].role:guestOf([keyid:MarchHare])
+#
+# [keyid:Party].role:about_other_party([keyid:tea],[?],[integer:99],[time:?AAA],
+#                  [integer:?BBB],[boolean:true],[integer:?]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_string([string:'a confused party']) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_string2([string:'a mangled \\'string\\''])
+#                 <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_urn([urn:'file://user/local/party/~sillyparty'])
+#                 <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_another_float([float:0.22]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_another_float([float:8]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_float([float:-200.0]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_another_integer([integer:-7]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_integer([integer:4]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_boolean([boolean:true]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_key([keyid:tea]) <- [keyid:MarchHare] 
+#
+# [keyid:Party].role:about_another_time([time:20201101T182930]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:about_time([time:20201101T]) <- [keyid:MarchHare]
+#
+# [keyid:Party].role:guestof([principal:?V]) 
+#                           <- [keyid:Party].role:friendOf([principal:?V])
+#
+# [keyid:Party].role:guests <- [keyid:Party].role:friendOf([keyid:MarchHare])
+#
+# [keyid:Party].role:friendOf([keyid:MarchHare]) <- [keyid:Dormouse]
+#
+# [keyid:Party].role:friendOf([keyid:Alice]) <- [keyid:Hatter]
 
 
-#[keyid:Party].role:about([keyid:tea],[time:201010],[string:'guest list'],[boolean:true],[integer:4]) <- [keyid:Party].role:guestOf([keyid:MarchHare])
-#echo "creddy --attribute --issuer Party_ID.pem --key Party_private.pem --role \"$about_party\" --subject-cert Party_ID.pem --subject-role  \"$guestof_marchhare\" --out party_about_party__guestof_marchhare_attr.der"
-creddy --attribute \
-       --issuer Party_ID.pem --key Party_private.pem --role "$about_party" \
-       --subject-cert Party_ID.pem --subject-role  "$guestof_marchhare" \
-       --out party_about_party__guestof_marchhare_attr.der
-#echo "  "
-#echo "double checking with creddy --roles -certs party_about_party__guestof_marchhare_attr.der"
-#creddy --roles --cert party_about_party__guestof_marchhare_attr.der
+
+
+
+
+
+
+
+
+
 
 #[keyid:Party].role:about_other_party([keyid:$tea_keyid],[time:?],[boolean:true]) <- [keyid:MarchHare]
Index: examples/python_tests/alice_rt1/alice.save
===================================================================
--- examples/python_tests/alice_rt1/alice.save	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alice_rt1/alice.save	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,11 +1,3 @@
 % Restoring file /usr/local/lib/Yap/startup.yss
-
-===good============ Party.guests <- dourmouse
-YAP query succeed
-pParty.guests <- pParty.friendOf(pMarchhare)
-pParty.friendOf(pMarchhare) <- pDormouse
-
-===bad============ Party.guests <- hatter
-YAP query failed
 
 ...final principal set...
@@ -16,6 +8,4 @@
 (pParty,keyid,y) 
 (pTea,keyid,y) 
-
-
 
 ...final policy attribute set...
@@ -28,5 +18,5 @@
 pParty.about_key(pTea) <- pMarchhare
 pParty.about_other_party(pTea,_,99,AAA,BBB,true,_) <- pMarchhare
-pParty.about(pTea,time(2010,10,10,00,00,00),true,4,-200.0,8,time(2012,02,05,18,29,30),'guest','file://usr/party/~teaparty') <- pParty.guestOf(pMarchhare)
+pParty.about(pTea,time(2010,10,10,00,00,00),true,4,-200.0,8,time(2012,02,05,18,29,30),'a list','file://usr/party/~teaparty') <- pParty.guestOf(pMarchhare)
 pParty.about_string2('a mangled \'string\'') <- pMarchhare
 pParty.about_string('a confused party') <- pMarchhare
@@ -39,3 +29,9 @@
 pParty.guests <- pParty.friendOf(pMarchhare)
 
+===good============ Party.guests <- dourmouse
+YAP query succeed
+pParty.guests <- pParty.friendOf(pMarchhare)
+pParty.friendOf(pMarchhare) <- pDormouse
 
+===bad============ Party.guests <- hatter
+YAP query failed
Index: examples/python_tests/alice_rt1/attr.py
===================================================================
--- examples/python_tests/alice_rt1/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alice_rt1/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,8 +2,8 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 
@@ -11,11 +11,14 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
-
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+
+# retrieve principals' keyid value from local credential files
 out = ctxt.context_principals()
 print "...initial principal set..."
@@ -59,7 +62,9 @@
 # and could not push/pull out of ietf_attribute_t properly
 ###############################################
+# NOTE: space and '~' in string value
+#       time value's optional ending
 # [keyid:Party].role: about([keyid:tea],[time:20101010T],[boolean:true],
 #                           [integer:4],[float:-200.0],[float:8],[time:20120205T182930],
-#                           [string:'guest'],[urn:'file://usr/party/~teaparty'])
+#                           [string:'a list'],[urn:'file://usr/party/~teaparty'])
 #                <- [keyid:Party].role:guestOf([keyid:MarchHare])
 head=ABAC.Role(party,"about")
@@ -78,5 +83,5 @@
 param=ABAC.DataTerm("time","20120205T182930")
 head.role_add_data_term(param)
-param=ABAC.DataTerm("string","'guest'")
+param=ABAC.DataTerm("string","'a list'")
 head.role_add_data_term(param)
 param=ABAC.DataTerm("urn","'file://usr/party/~teaparty'")
@@ -95,4 +100,6 @@
 
 ###############################################
+# NOTE: anonymous parameter
+#       Variable value for different parameter types
 # [keyid:Party].role:about_other_party([keyid:tea],[?],
 #                         [integer:99],[time:?AAA],[integer:?BBB],
@@ -141,4 +148,5 @@
 
 ###############################################
+# NOTE: how to escape within a string value
 # [keyid:Party].role:about_string2([string:'a mangled \\'string\\''])
 #                 <- [keyid:MarchHare]
@@ -317,4 +325,5 @@
 
 ###############################################
+# NOTE: principal parameter type
 # [keyid:Party].role:guestof([principal:?V]) 
 #           <- [keyid:Party].role:friendOf([principal:?V])
@@ -370,4 +379,5 @@
 
 ###############################################
+# NOTE: named principal tail
 # [keyid:Party].role:friendOf([keyid:Alice]) 
 #                               <- [keyid:Hatter]
@@ -386,4 +396,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/alice_rt1/query.py
===================================================================
--- examples/python_tests/alice_rt1/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alice_rt1/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 aliceID=ABAC.ID("Alice_ID.pem")
 aliceID.id_load_privkey_file("Alice_private.pem")
@@ -44,7 +48,18 @@
 dormouse=dormouseID.id_keyid()
 
-
+##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
 
 ##########################################################################
+# can dormouse be a guest at the party ?
 # role=[keyid:Party].role:guests 
 # p=[keyid:dormouse]
@@ -57,4 +72,5 @@
 
 ##########################################################################
+# can hatter be a guest at the party ?
 # role=[keyid:Party].role:guests 
 # p=[keyid:hatter]
@@ -66,16 +82,2 @@
     print "%s <- %s" % (c.head_string(), c.tail_string())
 
-
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
Index: examples/python_tests/alice_rt1/run_test
===================================================================
--- examples/python_tests/alice_rt1/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alice_rt1/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/alice_rt1/setup.py
===================================================================
--- examples/python_tests/alice_rt1/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alice_rt1/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,6 +2,5 @@
 
 """
-  Setup principal ID credentials
-
+See README for the semantics.  This creates many principals.
 """
 import os
Index: examples/python_tests/alumni2_rt1/README
===================================================================
--- examples/python_tests/alumni2_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni2_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,3 +1,2 @@
-#!/bin/sh
 #
 # This example shows an example of reasoning about a role's parameters.  There
@@ -14,56 +13,20 @@
 # psychology degree).
 #
-# The attached ./run_query file asks if each of these principals are favored
+# The query.py file asks if each of these principals are favored
 # alums, and only Bob is.
 
-# alumni2_rt1_typeD
+# alumni2_rt1
 
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Bob] (yes)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Maryann] (no)
-# [keyid:stateU].role:foundingAlumni <-?- [keyid:Joe] (no)
+# Credential #1
+# [keyid:stateU].role:foundingAlumni 
+#       <- [keyid:stateU].role:diploma([?], [integer:?Year:[1960,1961,1963]])
 
-creddy --generate --cn StateU
-creddy --generate --cn Bob
-creddy --generate --cn Maryann
-creddy --generate --cn Joe
+# Credential 2
+# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1961]) <- [keyid:bob]
 
-stateU_keyid=`creddy --keyid --cert StateU_ID.pem`
-bob_keyid=`creddy --keyid --cert Bob_ID.pem`
-maryann_keyid=`creddy --keyid --cert Maryann_ID.pem`
-joe_keyid=`creddy --keyid --cert Joe_ID.pem`
+# Credential 3
+# [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) <- [keyid:joe]
 
-diploma_q_qY="diploma([?], [integer:?Year:[1960,1961,1963]])"
+# Credential 4
+# [keyid:stateU].role:diploma([string:'psychology'],[integer:1962]) <- [keyid:maryann]
 
-diploma_m="diploma([string:'mathmatics'],[integer:1961])"
-diploma_z="diploma([string:'zoology'],[integer:1955])"
-diploma_p="diploma([string:'psychology'],[integer:1962])"
-
-# [keyid:stateU].role:foundingAlumni 
-#                   <- [keyid:stateU].role:diploma([?], [integer:?Year:[1960,1961,1963]])
-# Credential 1
-creddy --attribute \
-       --issuer StateU_ID.pem --key StateU_private.pem --role "foundingAlumni" \
-       --subject-cert StateU_ID.pem --subject-role "$diploma_q_qY" \
-       --out StateU_foundingAlumni__stateU_diploma_q_qY_attr.der
-
-# [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1961]) <- [keyid:bob]
-# Credential 2
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_m" \
-        --subject-cert Bob_ID.pem \
-        --out StateU_diploma_m__Bob_attr.der
-
-# [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) <- [keyid:joe]
-# Credential 3
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_z" \
-        --subject-cert Joe_ID.pem \
-        --out StateU_diploma_m__Joe_attr.der
-
-# [keyid:stateU].role:diploma([string:'psychology'],[integer:1962]) <- [keyid:maryann]
-# Credential 4
-creddy --attribute \
-        --issuer StateU_ID.pem --key StateU_private.pem --role "$diploma_p" \
-        --subject-cert Maryann_ID.pem \
-        --out StateU_diploma_m__Maryann_attr.der
-
Index: examples/python_tests/alumni2_rt1/attr.py
===================================================================
--- examples/python_tests/alumni2_rt1/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/alumni2_rt1/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,8 +2,8 @@
 
 """
-  Setup access policy attribute rules
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
-
 """
 
@@ -11,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -30,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 stateUID=ABAC.ID("StateU_ID.pem")
 stateUID.id_load_privkey_file("StateU_private.pem")
@@ -48,12 +51,23 @@
 
 ################################################
+# Credential 1, Any alumni of stateU is a member of foundingAlumni if
+# they have diploma from those specific years
 # [keyid:stateU].role:foundingAlumni
-#                   <- [keyid:stateU].role:diploma([?], [integer:?Year:[1960,1961,1963]])
+#       <- [keyid:stateU].role:diploma([?], [integer:?Year:[1960,1961,1963]])
 head = ABAC.Role(stateU,"foundingAlumni")
+
+# constructing an anonymous parameter
 param1=ABAC.DataTerm("anonymous", "_")
+
+# initialize a integer range constraint
 cond=ABAC.Constraint("integer")
+
+# add specific target value for the integer range constraint
 cond.constraint_add_integer_target(1960)
 cond.constraint_add_integer_target(1961)
 cond.constraint_add_integer_target(1963)
+
+# create a paramter term that has a range constraint on it,
+# the variable name supplied has to start with a capitalized alphabet character
 param2=ABAC.DataTerm("integer", "Year", cond)
 tail = ABAC.Role(stateU,"diploma")
@@ -61,5 +75,9 @@
 tail.role_add_data_term(param2)
 attr=ABAC.Attribute(head, 1800)
+
+# construct the attribute
 attr.attribute_add_tail(tail)
+
+# finalize the attribute
 attr.attribute_bake()
 attr.attribute_write_cert("StateU_foundingAlumni__stateU_diploma_q_qY_attr.der")
@@ -70,4 +88,5 @@
 
 #################################################
+# Credential 2
 # [keyid:stateU].role:diploma([string:'mathmatics'],[integer:1961]) <- [keyid:bob]
 param1=ABAC.DataTerm("string", "'mathmatics'")
@@ -87,4 +106,5 @@
 
 #################################################
+# Credential 3
 # [keyid:stateU].role:diploma([string:'zoology'],[integer:1955]) <- [keyid:joe]
 param1=ABAC.DataTerm("string", "'zoology'")
@@ -104,4 +124,5 @@
 
 #################################################
+# Credential 4
 # [keyid:stateU].role:diploma([string:'psychology'],[integer:1962]) <- [keyid:maryann]
 param1=ABAC.DataTerm("string", "'psychology'")
@@ -120,4 +141,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
